Index: NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg
===================================================================
--- NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg	(revision 12074)
+++ NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg	(revision 12082)
@@ -148,8 +148,6 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-/
-!-----------------------------------------------------------------------
-&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
-!-----------------------------------------------------------------------
+   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
+
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg
===================================================================
--- NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 12074)
+++ NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 12082)
@@ -148,8 +148,6 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-/
-!-----------------------------------------------------------------------
-&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
-!-----------------------------------------------------------------------
+   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
+
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg
===================================================================
--- NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg	(revision 12074)
+++ NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg	(revision 12082)
@@ -148,8 +148,6 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-/
-!-----------------------------------------------------------------------
-&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
-!-----------------------------------------------------------------------
+   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
+
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg
===================================================================
--- NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 12074)
+++ NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 12082)
@@ -148,8 +148,6 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-/
-!-----------------------------------------------------------------------
-&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
-!-----------------------------------------------------------------------
+   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
+
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg
===================================================================
--- NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 12074)
+++ NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 12082)
@@ -122,5 +122,5 @@
    ln_NCAR      = .true.    ! "NCAR"      algorithm   (Large and Yeager 2008)
    ln_COARE_3p0 = .false.   ! "COARE 3.0" algorithm   (Fairall et al. 2003)
-   ln_COARE_3p6 = .false.   ! "COARE 3.6" algorithm   (Edson et al. 2013)
+   ln_COARE_3p6 = .false.   ! "COARE 3.5" algorithm   (Edson et al. 2013)
    ln_ECMWF     = .false.   ! "ECMWF"     algorithm   (IFS cycle 31)
       rn_zqt    =  2.5      !  Air temperature & humidity reference height (m) [PAPA station]
@@ -148,8 +148,6 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-/
-!-----------------------------------------------------------------------
-&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
-!-----------------------------------------------------------------------
+   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
+
 /
 !-----------------------------------------------------------------------