Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg	(revision 12083)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6-noskin_cfg	(revision 12084)
@@ -148,6 +148,8 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
-
+/
+!-----------------------------------------------------------------------
+&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
+!-----------------------------------------------------------------------
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 12083)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 12084)
@@ -148,6 +148,8 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
-
+/
+!-----------------------------------------------------------------------
+&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
+!-----------------------------------------------------------------------
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg	(revision 12083)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf-noskin_cfg	(revision 12084)
@@ -148,6 +148,8 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
-
+/
+!-----------------------------------------------------------------------
+&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
+!-----------------------------------------------------------------------
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 12083)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 12084)
@@ -148,6 +148,8 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
-
+/
+!-----------------------------------------------------------------------
+&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
+!-----------------------------------------------------------------------
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 12083)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 12084)
@@ -148,6 +148,8 @@
    sn_snow     = 'Station_PAPA_50N-145W_precip_daily', 24., 'snow',     .false.    , .false. , 'yearly'  , ''  , ''   , ''
    sn_slp      = 'Station_PAPA_50N-145W_atm_hourly',  1.  , 'slp',      .true.     , .false. , 'yearly'  , ''  , ''   , ''
-   sn_tdif     = 'Station_PAPA_50N-145W_atm_hourly', 24.  , 'taudif'  , .false.    , .false. , 'yearly'  , ''  , ''   , ''
-
+/
+!-----------------------------------------------------------------------
+&namsbc_abl    !   Atmospheric Boundary Layer formulation           (ln_abl = T)
+!-----------------------------------------------------------------------
 /
 !-----------------------------------------------------------------------